Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorAction.cs	(revision 9194)
@@ -0,0 +1,108 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item("VariableVectorAction", "")]
+  public class VariableVectorAction : ItemDictionary<StringValue, IActionVariable>, IAction {
+
+    public int VirtualLength { get { return this.Values.Sum(x => x.VirtualLength); } }
+
+    [StorableConstructor]
+    protected VariableVectorAction(bool deserializing) : base(deserializing) { }
+    protected VariableVectorAction(VariableVectorAction original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public VariableVectorAction() : base() { }
+    public VariableVectorAction(int capacity) : base(capacity) { }
+    public VariableVectorAction(IDictionary<StringValue, IActionVariable> dictionary) : base(dictionary) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorAction(this, cloner);
+    }
+
+    protected override void OnItemsAdded(IEnumerable<KeyValuePair<StringValue, IActionVariable>> items) {
+      foreach (var item in items) {
+        if (!(item.Value is StringVariable || item.Value is IntVariable)) {
+          throw new ArgumentException("Value has to be of type 'StringVariable' or 'IntVariable'");
+        }
+      }
+      base.OnItemsAdded(items);
+    }
+
+    public bool Match(IAction target) {
+      var targetCast = target as VariableVectorAction;
+      if (targetCast == null) { return false; }
+      if (!(this.Keys.Except(targetCast.Keys).Count() == 0 && targetCast.Keys.Except(this.Keys).Count() == 0)) { return false; }
+      foreach (var keyValuePair in targetCast) {
+        if (!this[keyValuePair.Key].MatchVariable(keyValuePair.Value)) {
+          return false;
+        }
+      }
+      return true;
+    }
+
+    public void Add(IEnumerable<IActionVariable> action) {
+      foreach (var variable in action) {
+        this.Add(new StringValue(variable.VariableName), variable);
+      }
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      bool first = true;
+      foreach (var variable in this.Values) {
+        if (!first) {
+          first = false;
+        } else {
+          sb.Append(";");
+        }
+        sb.Append(variable.ToString());
+      }
+      return sb.ToString();
+    }
+
+    public void Randomize(IRandom random) {
+      foreach (var variable in this.Values) {
+        variable.Randomize(random);
+      }
+    }
+
+    public bool Identical(VariableVectorCondition target) {
+      if (!(target.Keys.Except(this.Keys).Count() == 0 && this.Keys.Except(target.Keys).Count() == 0)) { return false; }
+      foreach (var keyValuePair in target) {
+        if (!this[keyValuePair.Key].Identical(keyValuePair.Value)) {
+          return false;
+        }
+      }
+      return true;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCondition.cs	(revision 9194)
@@ -0,0 +1,102 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item("VariableVectorCondition", "")]
+  public class VariableVectorCondition : ItemDictionary<StringValue, IVariable>, ICondition {
+
+    public int VirtualLength { get { return this.Values.Sum(x => x.VirtualLength); } }
+
+    [StorableConstructor]
+    protected VariableVectorCondition(bool deserializing) : base(deserializing) { }
+    protected VariableVectorCondition(VariableVectorCondition original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public VariableVectorCondition() : base() { }
+    public VariableVectorCondition(int capacity) : base(capacity) { }
+    public VariableVectorCondition(IDictionary<StringValue, IVariable> dictionary) : base(dictionary) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorCondition(this, cloner);
+    }
+
+    public bool Match(IInput target) {
+      var targetCast = target as VariableVectorInput;
+      if (targetCast == null) { return false; }
+      if (!(targetCast.Keys.Except(this.Keys).Count() == 0 && this.Keys.Except(targetCast.Keys).Count() == 0)) { return false; }
+      foreach (var keyValuePair in targetCast) {
+        if (!this[keyValuePair.Key].MatchInput(keyValuePair.Value.Value)) {
+          return false;
+        }
+      }
+      return true;
+    }
+
+    public void Add(IEnumerable<IVariable> condition) {
+      foreach (var variable in condition) {
+        this.Add(new StringValue(variable.VariableName), variable);
+      }
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      bool first = true;
+      foreach (var variable in this.Values) {
+        if (!first) {
+          first = false;
+        } else {
+          sb.Append(";");
+        }
+        sb.Append(variable.ToString());
+      }
+      return sb.ToString();
+    }
+
+    public void Randomize(IRandom random, double spreadPercentage) {
+      foreach (var variable in this.Values) {
+        if (variable is DoubleVariable) {
+          ((DoubleVariable)variable).Randomize(random, spreadPercentage);
+        } else {
+          variable.Randomize(random);
+        }
+      }
+    }
+
+    public bool Identical(VariableVectorCondition target) {
+      if (!(target.Keys.Except(this.Keys).Count() == 0 && this.Keys.Except(target.Keys).Count() == 0)) { return false; }
+      foreach (var keyValuePair in target) {
+        if (!this[keyValuePair.Key].Identical(keyValuePair.Value)) {
+          return false;
+        }
+      }
+      return true;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCreator.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCreator.cs	(revision 9194)
@@ -0,0 +1,70 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [Item("VariableVectorCreator", "Description missing")]
+  [StorableClass]
+  public abstract class VariableVectorCreator : SingleSuccessorOperator, IVariableVectorCreator, IStochasticOperator {
+
+    #region Parameter Properties
+    public IValueLookupParameter<PercentValue> SpreadPercentageParameter {
+      get { return (IValueLookupParameter<PercentValue>)Parameters["SpreadPercentage"]; }
+    }
+    public IValueLookupParameter<VariableVector> SampleVariableVectorParameter {
+      get { return (IValueLookupParameter<VariableVector>)Parameters["SampleVariableVector"]; }
+    }
+    public ILookupParameter<VariableVector> VariableVectorParameter {
+      get { return (ILookupParameter<VariableVector>)Parameters["VariableVector"]; }
+    }
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected VariableVectorCreator(bool deserializing) : base(deserializing) { }
+    protected VariableVectorCreator(VariableVectorCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public VariableVectorCreator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<PercentValue>("SpreadPercentage", ""));
+      Parameters.Add(new ValueLookupParameter<VariableVector>("SampleVariableVector", ""));
+      Parameters.Add(new LookupParameter<VariableVector>("VariableVector", ""));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
+    }
+
+    public override IOperation Apply() {
+      VariableVectorParameter.ActualValue = Create(RandomParameter.ActualValue, SampleVariableVectorParameter.ActualValue, SpreadPercentageParameter.ActualValue.Value);
+      return base.Apply();
+    }
+
+    protected abstract VariableVector Create(IRandom random, VariableVector sampleVariableVector, double spreadPercentage);
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCrossover.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCrossover.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorCrossover.cs	(revision 9194)
@@ -0,0 +1,69 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [Item("VariableVectorCrossover", "Description missing")]
+  [StorableClass]
+  public abstract class VariableVectorCrossover : SingleSuccessorOperator, IVariableVectorCrossover {
+    public override bool CanChangeName {
+      get { return false; }
+    }
+
+    #region Parameter Properties
+    public ILookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ILookupParameter<ItemArray<VariableVector>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<VariableVector>)Parameters["Parents"]; }
+    }
+    public ILookupParameter<VariableVector> ChildParameter {
+      get { return (ILookupParameter<VariableVector>)Parameters["Child"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected VariableVectorCrossover(bool deserializing) : base(deserializing) { }
+    protected VariableVectorCrossover(VariableVectorCrossover original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public VariableVectorCrossover()
+      : base() {
+      Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic crossover operators."));
+      Parameters.Add(new ScopeTreeLookupParameter<VariableVector>("Parents", "The parent vectors which should be crossed."));
+      ParentsParameter.ActualName = "VariableVector";
+      Parameters.Add(new LookupParameter<VariableVector>("Child", "The child vector resulting from the crossover."));
+      ChildParameter.ActualName = "VariableVector";
+    }
+
+    public sealed override IOperation Apply() {
+      ChildParameter.ActualValue = Cross(RandomParameter.ActualValue, ParentsParameter.ActualValue);
+      return base.Apply();
+    }
+
+    protected abstract VariableVector Cross(IRandom random, ItemArray<VariableVector> parents);
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVectorInput.cs	(revision 9194)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item("VariableVectorInput", "")]
+  public class VariableVectorInput : ItemDictionary<StringValue, StringValue>, IInput {
+
+    [StorableConstructor]
+    protected VariableVectorInput(bool deserializing) : base(deserializing) { }
+    protected VariableVectorInput(VariableVectorInput original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public VariableVectorInput() : base() { }
+    public VariableVectorInput(int capacity) : base(capacity) { }
+    public VariableVectorInput(IDictionary<StringValue, StringValue> dictionary) : base(dictionary) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVectorInput(this, cloner);
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/HeuristicLab.Problems.ConditionActionClassification-3.3.csproj	(revision 9194)
@@ -44,8 +44,4 @@
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core-3.3">
-      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -100,4 +96,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.CombinedIntegerVectorEncoding\3.3\HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj">
       <Project>{CE7163C5-BFFE-45F0-9BD0-E10EF24E8BD2}</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblem.cs	(revision 9194)
@@ -69,6 +69,6 @@
       get { return (IFixedValueParameter<DoubleValue>)Parameters["InitialFitness"]; }
     }
-    public IFixedValueParameter<ItemSet<IClassifier>> PossibleActionsParameter {
-      get { return (IFixedValueParameter<ItemSet<IClassifier>>)Parameters["PossibleActions"]; }
+    public IFixedValueParameter<ItemSet<IAction>> PossibleActionsParameter {
+      get { return (IFixedValueParameter<ItemSet<IAction>>)Parameters["PossibleActions"]; }
     }
     public IFixedValueParameter<ItemSet<CombinedIntegerVector>> PossibleActionsConcreteClassParameter {
@@ -77,4 +77,7 @@
     public IFixedValueParameter<IntValue> ThetaMinimalNumberOfActionsParameter {
       get { return (IFixedValueParameter<IntValue>)Parameters["ThetaMinimalNumberOfActions"]; }
+    }
+    public IFixedValueParameter<HeuristicLab.Encodings.CombinedIntegerVectorEncoding.CombinedIntegerVector.CombinedIntegerVectorComparer> ClassifierComparerParameter {
+      get { return (IFixedValueParameter<HeuristicLab.Encodings.CombinedIntegerVectorEncoding.CombinedIntegerVector.CombinedIntegerVectorComparer>)Parameters["ClassifierComparer"]; }
     }
     #endregion
@@ -108,5 +111,5 @@
     //  get { return PossibleActions; }
     //}
-    public ItemSet<IClassifier> PossibleActions {
+    public ItemSet<IAction> PossibleActions {
       get { return PossibleActionsParameter.Value; }
     }
@@ -148,4 +151,10 @@
     IParameter IConditionActionProblem.CoveringSolutionCreatorParameter {
       get { return CoveringSolutionCreatorParameter; }
+    }
+    public IClassifierComparer ClassifierComparer {
+      get { return ClassifierComparerParameter.Value; }
+    }
+    IParameter IConditionActionProblem.ClassifierComparerParameter {
+      get { return ClassifierComparerParameter; }
     }
     #endregion
@@ -177,6 +186,7 @@
       Parameters.Add(new ValueParameter<IActionExecuter>(ActionExecuterParameterName, "", new ActionExecuter()));
       Parameters.Add(new ValueParameter<ClassifierFetcher>(ClassifierFetcherParameterName, "", new ClassifierFetcher()));
-      Parameters.Add(new FixedValueParameter<ItemSet<IClassifier>>("PossibleActions"));
-      Parameters.Add(new FixedValueParameter<ItemSet<CombinedIntegerVector>>("PossibleActionsConcreteClass"));
+      Parameters.Add(new FixedValueParameter<HeuristicLab.Encodings.CombinedIntegerVectorEncoding.CombinedIntegerVector.CombinedIntegerVectorComparer>("ClassifierComparer", new HeuristicLab.Encodings.CombinedIntegerVectorEncoding.CombinedIntegerVector.CombinedIntegerVectorComparer()));
+      Parameters.Add(new FixedValueParameter<ItemSet<IAction>>("PossibleActions", new ItemSet<IAction>(ClassifierComparer)));
+      Parameters.Add(new FixedValueParameter<ItemSet<CombinedIntegerVector>>("PossibleActionsConcreteClass", new ItemSet<CombinedIntegerVector>(ClassifierComparer)));
       Parameters.Add(new FixedValueParameter<IntValue>("ThetaMinimalNumberOfActions", "Minimal number of actions, which have to be present in the match set, or else covering will occure.", new IntValue(1)));
 
@@ -191,10 +201,10 @@
 
       coveringSolutionCreator.ChangeSymbolProbabilityParameter.ActualName = ChangeSymbolProbabilityInCoveringParameter.Name;
-      coveringSolutionCreator.CoverClassifierParameter.ActualName = ClassifierFetcher.CurrentClassifierToMatchParameter.ActualName;
+      coveringSolutionCreator.CoverInputParameter.ActualName = ClassifierFetcher.CurrentInputToMatchParameter.ActualName;
       coveringSolutionCreator.CreatedClassifierParameter.ActualName = "CombinedIntegerVector";
 
       ClassifierFetcher.ProblemDataParameter.ActualName = ProblemDataParameter.Name;
 
-      ActionExecuter.CurrentClassifierToMatchParameter.ActualName = ClassifierFetcher.CurrentClassifierToMatchParameter.ActualName;
+      ActionExecuter.CurrentActionToMatchParameter.ActualName = ClassifierFetcher.CurrentActionToMatchParameter.ActualName;
       ActionExecuter.NegativeRewardParameter.ActualName = NegativeRewardParameter.Name;
       ActionExecuter.PositiveRewardParameter.ActualName = PositiveRewardParameter.Name;
@@ -241,4 +251,5 @@
         xcsAnalyzer.ProblemDataParameter.ActualName = ProblemDataParameter.Name;
         xcsAnalyzer.ResultsParameter.ActualName = "Results";
+        xcsAnalyzer.ClassifierComparerParameter.ActualName = ClassifierComparerParameter.Name;
       }
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/Implementation/ConditionActionClassificationProblemData.cs	(revision 9194)
@@ -119,7 +119,4 @@
     #endregion
 
-    private IDictionary<int, IClassifier> fetchClassifiersCache = new Dictionary<int, IClassifier>();
-
-
     [StorableConstructor]
     protected ConditionActionClassificationProblemData(bool deserializing) : base(deserializing) { }
@@ -201,11 +198,24 @@
     }
 
-    public IEnumerable<IClassifier> FetchClassifier(IEnumerable<int> rows) {
+    public IEnumerable<IInput> FetchInput(IEnumerable<int> rows) {
       foreach (var row in rows) {
-        yield return FetchClassifier(row);
-      }
-    }
-
-    public IClassifier FetchClassifier(int rowNumber) {
+        yield return FetchInput(row);
+      }
+    }
+    public IInput FetchInput(int rowNumber) {
+      return FetchClassifier(rowNumber).Condition as IInput;
+    }
+    public IEnumerable<IAction> FetchAction(IEnumerable<int> rows) {
+      foreach (var row in rows) {
+        yield return FetchAction(row);
+      }
+    }
+    public IAction FetchAction(int rowNumber) {
+      return FetchClassifier(rowNumber).Action;
+    }
+    #region fetchHelper
+    private IDictionary<int, IClassifier> fetchClassifiersCache = new Dictionary<int, IClassifier>();
+
+    private IClassifier FetchClassifier(int rowNumber) {
       if (!fetchClassifiersCache.ContainsKey(rowNumber)) {
         int[] elements = new int[Length.Value];
@@ -231,4 +241,5 @@
       return fetchClassifiersCache[rowNumber];
     }
+    #endregion
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.Instances.ConditionActionClassification/3.3/HeuristicLab.Problems.Instances.ConditionActionClassification.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.Instances.ConditionActionClassification/3.3/HeuristicLab.Problems.Instances.ConditionActionClassification.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.Instances.ConditionActionClassification/3.3/HeuristicLab.Problems.Instances.ConditionActionClassification.csproj	(revision 9194)
@@ -39,5 +39,4 @@
   <ItemGroup>
     <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
@@ -67,4 +66,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.ConditionActionEncoding\3.3\HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj">
       <Project>{422FB262-0845-4969-8D16-12F057AA90B1}</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.XCS.Views/3.3/HeuristicLab.Problems.XCS.Views-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.XCS.Views/3.3/HeuristicLab.Problems.XCS.Views-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.XCS.Views/3.3/HeuristicLab.Problems.XCS.Views-3.3.csproj	(revision 9194)
@@ -41,5 +41,4 @@
     <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.MainForm-3.3">
@@ -78,4 +77,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.ConditionActionEncoding\3.3\HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj">
       <Project>{422FB262-0845-4969-8D16-12F057AA90B1}</Project>
